
program cairo09;

uses
  Cairo;

{$I Couleurs.inc}

const
  w = 256;

procedure SetSourceColor(cr: Pcairo_t; color: longword);
var
  r, g, b: double;
begin
  r := (color and $FF0000) / $FF0000;
  g := (color and $00FF00) / $00FF00;
  b := (color and $0000FF) / $0000FF;
  cairo_set_source_rgb(cr, r, g, b);
end;

procedure Arc(cr: Pcairo_t; x, y, r, a1, a2, w: double; col: longword);
begin
  cairo_set_line_width(cr, w);
  SetSourceColor(cr, col);
  cairo_arc(cr, x, y, r, a1, a2);
  cairo_stroke(cr);
end;

var
  cr: PCairo_t;
  surface: Pcairo_surface_t;
  i: integer;

begin
  surface := cairo_image_surface_create(CAIRO_FORMAT_ARGB32, w, w);
  cr := cairo_create(surface);
  cairo_set_line_cap(cr, CAIRO_LINE_CAP_ROUND);

  SetSourceColor(cr, couleurs[7, 21]);
  cairo_paint(cr);

  for i := 0 to 3 do
  begin
    Arc(
      cr,
      w / 2,
      w / 2,
      (w / 4) + (w / 16) * i,
      7 * PI / 6 - (PI / 10) * i,
      5 * PI / 6 - (PI / 10) * i,
      8 - 4 * i / 3,
      couleurs[7, 6 + 4 * i]
    );
  end;

  cairo_surface_write_to_png(surface, 'image.png');
  cairo_destroy(cr);
  cairo_surface_destroy(surface);
end.
